• Willkommen im Linux Club - dem deutschsprachigen Supportforum für GNU/Linux. Registriere dich kostenlos, um alle Inhalte zu sehen und Fragen zu stellen.

ksmarttray ohne passwortabfrage [Gelöst]

1queery

Newbie
Ich habe mich an meinem ersten runlevel script versucht und das ganze anhandt der Anleitungen http://www.linux-club.de/viewtopic.php?t=16069 und http://de.opensuse.org/SDB:Create_your_own_init_scripts geschrieben. Ziel ist das ksmarttray beim starten mit root rechten gestartet wird ohne das ich immer wieder ein passwort eingeben muss.

Das script heißt ksmarttray und lässt sich auch mittels /etc/init.d/ksmarttray start problemlos starten und mittels /etc/init.d/ksmarttray stop stoppen

In der "boot.msg" steht allerdings nach dem booten:
ksmarttray: ERROR: KUniqueApplication: Can't determine DISPLAY. Aborting.
Vielleicht könnt ihr mir helfen...

Das script sieht so aus (gekürzt):
#!/bin/sh

(...)

### BEGIN INIT INFO
# Provides: ksmarttray
# Required-Start: $ALL
# Required-Stop:
# Default-Start: 5
# Default-Stop:
# Short-Description: Smart - Package Update Checker
### END INIT INFO

(...)

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
KSMARTTRAY_BIN=/opt/kde3/bin/ksmarttray
test -x $KSMARTTRAY_BIN || { echo "$KSMARTTRAY_BIN not installed";
if [ "$1" = "stop" ]; then exit 0;
else exit 5; fi; }


# Source LSB init functions
# providing start_daemon, killproc, pidofproc,
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
# rc_check check and set local and overall rc status
# rc_status check and set local and overall rc status
# rc_status -v be verbose in local rc status and clear it afterwards
# rc_status -v -r ditto and clear both the local and overall rc status
# rc_status -s display "skipped" and exit with status 3
# rc_status -u display "unused" and exit with status 3
# rc_failed set local and overall rc status to failed
# rc_failed <num> set local and overall rc status to <num>
# rc_reset clear both the local and overall rc status
# rc_exit exit appropriate to overall rc status
# rc_active checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0 - success
# 1 - generic or unspecified error
# 2 - invalid or excess argument(s)
# 3 - unimplemented feature (e.g. "reload")
# 4 - user had insufficient privileges
# 5 - program is not installed
# 6 - program is not configured
# 7 - program is not running
# 8--199 - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
#
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

case "$1" in
start)
echo -n "Starting ksmarttray "
## Start daemon with startproc(8). If this fails
## the return value is set appropriately by startproc.
/sbin/startproc $KSMARTTRAY_BIN

# Remember status and be verbose
rc_status -v
;;
stop)
echo -n "Shutting down ksmarttray "
## Stop daemon with killproc(8) and if this fails
## killproc sets the return value according to LSB.

/sbin/killproc -TERM $KSMARTTRAY_BIN

# Remember status and be verbose
rc_status -v
;;
try-restart|condrestart)
## Do a restart only if the service was active before.
## Note: try-restart is now part of LSB (as of 1.9).
## RH has a similar command named condrestart.
if test "$1" = "condrestart"; then
echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
fi
$0 status
if test $? = 0; then
$0 restart
else
rc_reset # Not running is not a failure.
fi
# Remember status and be quiet
rc_status
;;
restart)
## Stop the service and regardless of whether it was
## running or not, start it again.
$0 stop
$0 start

# Remember status and be quiet
rc_status
;;
force-reload)
## Signal the daemon to reload its config. Most daemons
## do this on signal 1 (SIGHUP).
## If it does not support it, restart the service if it
## is running.

echo -n "Reload service ksmarttray "
## if it supports it:
/sbin/killproc -HUP $KSMARTTRAY_BIN
#touch /var/run/FOO.pid
rc_status -v

## Otherwise:
#$0 try-restart
#rc_status
;;
reload)
## Like force-reload, but if daemon does not support
## signaling, do nothing (!)

# If it supports signaling:
echo -n "Reload service ksmarttray "
/sbin/killproc -HUP $KSMARTTRAY_BIN
#touch /var/run/FOO.pid
rc_status -v

## Otherwise if it does not support reload:
#rc_failed 3
#rc_status -v
;;
status)
echo -n "Checking for service ksmarttray "
## Check status with checkproc(8), if process is running
## checkproc will return with exit status 0.

# Return value is slightly different for the status command:
# 0 - service up and running
# 1 - service dead, but /var/run/ pid file exists
# 2 - service dead, but /var/lock/ lock file exists
# 3 - service not running (unused)
# 4 - service status unknown :-(
# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)

# NOTE: checkproc returns LSB compliant status values.
/sbin/checkproc $KSMARTTRAY_BIN
# NOTE: rc_status knows that we called this init script with
# "status" option and adapts its messages accordingly.
rc_status -v
;;
*)
echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload}"
exit 1
;;
esac
rc_exit
 
X-Programme kann man nicht mit einem Initskript starten, weil sie einen laufenden X-Server voraussetzen, der aber erst dann zur Verfügung steht, wenn die Initskripte schon längst abgearbeitet sind.

Wenn Du die root-Passwort-Abfrage loswerden willst, sind folgende Schritte zu unternehmen:

1. Setze das SUID-Bit auf /usr/sbin/smart-update:
Code:
echo "/usr/sbin/smart-update root.root 4755" >> /etc/permissions.local
/sbin/SuSEconfig --module permissions
2. Entferne die Zeilen
Code:
X-KDE-SubstituteUID=true
X-KDE-Username=root
aus /usr/share/applications/smart-ksmarttray.desktop.
 
OP
1

1queery

Newbie
...klingt logisch. Vielen Dank für die Lösung.

Bei mir startet Ksmarttray jetzt ohne Passwort.
2. Entferne die Zeilen
Code:
X-KDE-SubstituteUID=true
X-KDE-Username=root
aus /usr/share/applications/smart-ksmarttray.desktop.
bei mir lag das ganze allerdings unter:
/opt/kde3/share/applications/kde/smart-ksmarttray.desktop
 
Das liegt an den unterschiedlichen Paketen. Es gibt ja bekanntermaßen zwei primäre Quellen für smart-RPMs, und ksmarttray kommt standardmäßig ganz ohne .desktop-Datei, also gibt es auch nichts, woran man sich eindeutig orientieren könnte.

Dir ist aber schon klar, dass Du, um sinnvoll ohne Passwort-Abfrage mit ksmarttray arbeiten zu können, beide Schritte durchführen musst? Ansonsten fragt ksmarttray zwar nicht mehr nach dem Passwort, kann aber andererseits auch keine Channel-Informationen aktualisieren. Das geht nämlich nur mit root-Rechten, also brauchst Du entweder die Passwort-Abfrage oder aber das SUID-Bit auf smart-update.

Noch was: Wenn Du das andere smart-RPM verwendest, dann ist wahrscheinlich nicht nur smart-ksmarttray.desktop an einem anderen Ort, sondern auch smart-update:

/usr/sbin/smart-update -> /usr/bin/smart-update
 
OP
1

1queery

Newbie
Nur als Info für andere, natürlich beide Schritte ausführen und smart-update war bei mir in der Tat unter bin und nicht sbin.
 
Oben